pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 > Class Template Reference
Module filters

StatisticalOutlierRemoval uses point neighborhood statistics to filter outlier data. More...

`#include <pcl/filters/statistical_outlier_removal.h>`

Inheritance diagram for pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >:

## Public Member Functions

| StatisticalOutlierRemoval (bool extract_removed_indices=false)
| Empty constructor. More...
void | setMeanK (int nr_k)
| Set the number of points (k) to use for mean distance estimation. More...
int | getMeanK ()
| Get the number of points to use for mean distance estimation. More...
void | setStddevMulThresh (double std_mul)
| Set the standard deviation multiplier threshold. More...
double | getStddevMulThresh ()
| Get the standard deviation multiplier threshold as set by the user. More...
void | setNegative (bool negative)
| Set whether the indices should be returned, or all points except the indices. More...
bool | getNegative ()
| Get the value of the internal negative_ parameter. More...
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor. More...
virtual | ~PCLBase ()
| destructor. More...
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PCLPointCloud2ConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output)
| Abstract filter method. More...
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

int | mean_k_
| The number of points to use for mean distance estimation. More...
double | std_mul_
| Standard deviations threshold (i.e., points outside of will be marked as outliers). More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
bool | negative_
| If true, the outliers will be returned instead of the inliers (default: false). More...
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
std::string | filter_name_
| The filter name. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
std::vector< int > | field_sizes_
| The size of each individual field. More...
int | x_idx_
| The x-y-z fields indices. More...
int | y_idx_
int | z_idx_
std::string | x_field_name_
| The desired x-y-z field names. More...
std::string | y_field_name_
std::string | z_field_name_

## Additional Inherited Members

Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
typedef boost::shared_ptr< Filter< pcl::PCLPointCloud2 > > | Ptr
typedef boost::shared_ptr< const Filter< pcl::PCLPointCloud2 > > | ConstPtr
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef PCLPointCloud2::Ptr | PCLPointCloud2Ptr
typedef PCLPointCloud2::ConstPtr | PCLPointCloud2ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef boost::shared_ptr< PCLPointCloud2 > | PCLPointCloud2Ptr
typedef boost::shared_ptr< PCLPointCloud2 const > | PCLPointCloud2ConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Detailed Description

### template<>
class pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >

StatisticalOutlierRemoval uses point neighborhood statistics to filter outlier data.

For more information check:

- R. B. Rusu, Z. C. Marton, N. Blodow, M. Dolha, and M. Beetz. Towards 3D Point Cloud Based Object Maps for Household Environments Robotics and Autonomous Systems Journal (Special Issue on Semantic Knowledge), 2008.

Note
  setFilterFieldName (), setFilterLimits (), and setFilterLimitNegative () are ignored.

Author
  Radu Bogdan Rusu

Definition at line 201 of file statistical_outlier_removal.h.

## Constructor & Destructor Documentation

## StatisticalOutlierRemoval()

pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::StatisticalOutlierRemoval | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Definition at line 218 of file statistical_outlier_removal.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter()

void pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

protected virtual

Abstract filter method.

The implementation needs to set output.{data, row_step, point_step, width, height, is_dense}.

Parameters

  [out] | output | the resultant filtered point cloud

Implements pcl::Filter< pcl::PCLPointCloud2 >.

## getMeanK()

int pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::getMeanK | ( |  | ) |

inline

Get the number of points to use for mean distance estimation.

Definition at line 236 of file statistical_outlier_removal.h.

## getNegative()

bool pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::getNegative | ( |  | ) |

inline

Get the value of the internal negative_ parameter.

If true, all points except the input indices will be returned.

Returns
  The value of the "negative" flag

Definition at line 274 of file statistical_outlier_removal.h.

References pcl::FilterIndices< PointT >::negative_.

## getStddevMulThresh()

double pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::getStddevMulThresh | ( |  | ) |

inline

Get the standard deviation multiplier threshold as set by the user.

Definition at line 255 of file statistical_outlier_removal.h.

## setMeanK()

void pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::setMeanK | ( | int | nr_k | ) |

inline

Set the number of points (k) to use for mean distance estimation.

Parameters

  nr_k | the number of points to use for mean distance estimation

Definition at line 229 of file statistical_outlier_removal.h.

## setNegative()

void pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::setNegative | ( | bool | negative | ) |

inline

Set whether the indices should be returned, or all points except the indices.

Parameters

  negative | true if all points except the input indices will be returned, false otherwise

Definition at line 264 of file statistical_outlier_removal.h.

References pcl::FilterIndices< PointT >::negative_.

## setStddevMulThresh()

void pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::setStddevMulThresh | ( | double | std_mul | ) |

inline

Set the standard deviation multiplier threshold.

All points outside the

will be considered outliers, where is the estimated mean, and is the standard deviation.

Parameters

  std_mul | the standard deviation multiplier threshold

Definition at line 248 of file statistical_outlier_removal.h.

## Member Data Documentation

## mean_k_

int pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::mean_k_

protected

The number of points to use for mean distance estimation.

Definition at line 281 of file statistical_outlier_removal.h.

## negative_

bool pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::negative_

protected

If true, the outliers will be returned instead of the inliers (default: false).

Definition at line 292 of file statistical_outlier_removal.h.

## std_mul_

double pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::std_mul_

protected

Standard deviations threshold (i.e., points outside of will be marked as outliers).

Definition at line 286 of file statistical_outlier_removal.h.

## tree_

KdTreePtr pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::tree_

protected

A pointer to the spatial search object.

Definition at line 289 of file statistical_outlier_removal.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/statistical_outlier_removal.h